//###################################################################################
// File: gpslogger.c
//
// Store all NMEA messages from a gps-mouse on CF/MMC/SD until card is full.
//
//#########################################################################
// Last change: 28.07.2005
//#########################################################################
// hk@holger-klabunde.de
// http://www.holger-klabunde.de/index.html
//#########################################################################
// Compiler: AVR-GCC 3.4.5
//#########################################################################
#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>

#include "mydefs.h"
#include "protos.h"
#include "../lcd.h"
#include "../dos.h"
#include "../printf.h"
#include "../serial.h"

//###################################################################################
/* Hauptprogramm */
int main(void)
//###################################################################################
{
 unsigned char by,result;
 unsigned long bytecount;
 
 
 DDRC=0xFF;  	// set io-pins on PortC
 PORTC=0; 	//LCD-Datenbus

 DDRD=0xF2;  	// set io-pins on PortD
 PORTD=0x02; 	//LCD-Steuersignale siehe lcd.h

 DDRA=0; 	//Alles Eingnge
 PORTA=0xFF; 	//Eingnge mit Pullups setzen

 SFIOR&=!(1<<PUD); 	//Pullups Enable
// SFIOR=0; 	//Pullups Enable

 LCDInit();

#ifdef MMC_CARD_SPI //SD_CARD_SPI too !
 MMC_IO_Init();
#endif

 ser_init();
 
 sei();              //enable interrupts

 LCDCls();
 LCDWrite("GPS Logger");
 LCDPos(2,1);
 LCDWrite("by Holgi");
 Delay1ms(1000);
 LCDCls();

 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   LCDCls();
   LCDWrite("Flash meldet sich nicht !");
   while(1);
  }
  
 RED_ON();
 GREEN_OFF();

 bytecount=0;
 result=Fopen("nmea.gps",F_WRITE);
 if(result==F_OK)
  {
   do
    {
     by=ser_getc();
     if(Fwrite(&by,1)!=1) result=F_ERROR;
     bytecount++;
     LCDPos(1,1);
     ShowHexLong(bytecount);
    }while(result==F_OK );

   Fclose();
  }

 GREEN_ON();
 RED_OFF();
 cli(); // Disable interrupts

 for(;;) // loop forever
  {
  }
}

