//#########################################################################
// File: MYDEFS.H
//
//
//#########################################################################
// Last change: 04.09.2006
//#########################################################################
// Compiler: AVR-GCC 3.4.5
//#########################################################################

//don't check this to avoid warnings from WINAVR for builtin fread(),fwrite()......
//that WINAVR does not really have ;)
//#ifndef __MYDEFS_H
//#define __MYDEFS_H

// spare program memory by deciding if we want to read, write or both
#undef DOS_READ	//undefine this if you don't want to read files with fread()
#undef DOS_WRITE	//undefine this if you don't want to write files with fwrite()
                        //deleting files is also deactivated
#undef DOS_DELETE	//undefine this if you don't want to delete files
#undef DOS_READ_RAW	//undefine this if you don't want to read files with ReadFileRaw()

#undef DOS_MKDIR	//undefine this if you don't want to make subdirectories
//#undef DOS_CHDIR	//undefine this if you don't want to go into subdirectories

// spare program memory by deciding if we want to use FAT12, FAT16, FAT32.
// comment out FAT types not used. NOT recommended if you don't know the
// FAT type of your drive !
//#undef USE_FAT12	//undefine this if you don't want to use FAT12
//#undef USE_FAT16	//undefine this if you don't want to use FAT16
//#undef USE_FAT32	//undefine this if you don't want to use FAT32

#undef USE_FATBUFFER	//undefine this if you don't want to use a FAT buffer
                        //needs 517 Bytes of RAM ! 

//#undef USE_FINDFILE     //undefine this if you don't want to use findfirst(), findnext()
//#undef USE_FINDLONG     //undefine this if you don't want to get long filenames
			//from findfirst(); findnext();

#undef USE_DRIVEFREE	//undefine this if you don't want to get used and free space of your drive

//define your processor speed here !
//#define F_4
//#define F_6
//#define F_8  
//#define F_11059
#define F_16

#ifdef F_4
 #define F_CPU      4000000    //processor clock
#endif

#ifdef F_6
 #define F_CPU      6000000    //processor clock
#endif

#ifdef F_8
 #define F_CPU      8000000    //processor clock
#endif

#ifdef F_16
 #define F_CPU      16000000    //processor clock
#endif

#ifdef F_11059
 #define F_CPU      11059200    //processor clock
#endif

#define UART_BAUD_RATE	19200
//#define UART_BAUD_RATE	38400

#define T1_PRESCALER	8
#define T1_TICKS   	F_CPU / ( T1_PRESCALER * 65536 )	
#define T1_ONESECOND    T1_TICKS

#define NOP() asm volatile ("nop" ::)
//WinAVR 3.4.3 setzt die Bitsetzbefehle sbi(),cbi() ins Assembler-Listing fr diese
//beiden #defines ein ! Also kein Grund Inline Assembler zu benutzen.
#define sbi(portn, bitn) ((portn)|=(1<<(bitn)))
#define cbi(portn, bitn) ((portn)&=~(1<<(bitn)))
//#define sbi(portn, bitn) asm volatile("sbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))
//#define cbi(portn, bitn) asm volatile("cbi %0, %1" : : "I" (_SFR_IO_ADDR(portn)), "I" ((uint8_t)(bitn)))

#if defined (__AVR_ATmega32__) || defined (__AVR_ATmega323__)

 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTD   //Port where red LED is located
 #define RED_DDR 	DDRD    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTD   //Port where green LED is located
 #define GREEN_DDR 	DDRD    //Port direction register where green LED is located

#elif defined (__AVR_ATmega128__) || defined (__AVR_ATmega64__)
 #define RED_BIT	7	//Pin number for red LED
 #define RED_PORT 	PORTE   //Port where red LED is located
 #define RED_DDR 	DDRE    //Port direction register where red LED is located
 #define GREEN_BIT	6	//Pin number for green LED
 #define GREEN_PORT 	PORTE   //Port where green LED is located
 #define GREEN_DDR 	DDRE    //Port direction register where green LED is located
#else
#  error "processor type not defined in mydefs.h"
#endif

//Die beiden LED's
#define RED_ON() { sbi(RED_DDR,RED_BIT); cbi(RED_PORT,RED_BIT); } //LOW activ
#define RED_OFF() { sbi(RED_DDR,RED_BIT); sbi(RED_PORT,RED_BIT); } //LOW activ

#define GREEN_ON() { sbi(GREEN_DDR,GREEN_BIT); cbi(GREEN_PORT,GREEN_BIT); }  //LOW activ
#define GREEN_OFF() { sbi(GREEN_DDR,GREEN_BIT); sbi(GREEN_PORT,GREEN_BIT); } //LOW activ

//Prototypes of global variables
extern volatile unsigned char play_status;
extern unsigned char volume;


//#endif //__MYDEFS_H
